#!/usr/bin/python3

#
# Volcado de la base de datos de bbj a un directorio con un fichero
# de texto por cada hilo creado
#

import sqlite3
import os
import shutil
from datetime import datetime 

con = sqlite3.connect('data.sqlite')  # Fichero de de la base de datos -> /usr/local/share/bbj/data.sql
msg_directory="/tmp/bbj"              # Directorio de salida del volcado

users_list={}
threads_list={}

def threads(con):
    cur = con.cursor()
    cur.execute('SELECT * FROM threads')
    rows = cur.fetchall()

    for row in rows:
        thread_id=row[0]
        thread_title=row[2]
        thread_autor=row[1]
        thread_stamp=row[4]
        threads_list[thread_id]=(thread_title, users_list[thread_autor], thread_stamp)


def users(con):
    cur = con.cursor()
    cur.execute('SELECT * FROM users')
    rows = cur.fetchall()

    for row in rows:
        user_id=row[0]
        user_name=row[1]
        users_list[user_id]=user_name

# 
#   Formato de salida:
#   Cada hilo se guarda en un fichero txt separado. El nombre se forma con
#   la fecha y la hora y en su interior todos los mensajes ordenados y separados
#   por una marca de texto fácil de quitar
#
def save_thread(id):
    stamp=datetime.fromtimestamp(threads_list[id][2]).strftime("%Y%m%d%H%M")
    ftname=str(stamp)+"-"+threads_list[id][0].replace(" ","_")+".txt"
    ft = open(msg_directory+"/"+ftname,"w")

    cur = con.cursor()
    cur.execute('SELECT * FROM messages WHERE thread_id = "'+id+'";')
    rows = cur.fetchall()

    for row in rows:
        body=row[5]
        author=users_list[row[2]]
        ft.write("-----> "+author+ ":\n")
        ft.write(body)
        ft.write("\n\n\n")


if __name__ == '__main__':
    print ("Exportando datos de bbj a "+msg_directory+" ...")

    if os.path.exists(msg_directory):
        shutil.rmtree(msg_directory)
    os.makedirs(msg_directory)
    
    users(con)
    threads(con)
    
    for thread in threads_list:
        save_thread(thread)

